
#include <Arduino.h>
#include <ArduinoJson.h>
#include <ESP8266WiFi.h>
#include <ESP8266HTTPClient.h>
#include <WiFiClientSecureBearSSL.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>


const unsigned char NaN [] PROGMEM = {
  // 'ripple, 21x21px
  0x00, 0x07, 0x80, 0x00, 0x0f, 0xc0, 0x00, 0x1f, 0xe0, 0x00, 0x1f, 0xe0, 0x00, 0x1f, 0xe0, 0x00,
  0x1f, 0xe0, 0x1c, 0x1f, 0xe0, 0x7f, 0x1f, 0xc0, 0x7f, 0x1f, 0x00, 0xff, 0xf8, 0x00, 0xff, 0xf8,
  0x00, 0xff, 0xf8, 0x00, 0x7f, 0x1f, 0x80, 0x3e, 0x1f, 0xc0, 0x1c, 0x1f, 0xe0, 0x00, 0x1f, 0xe0,
  0x00, 0x1f, 0xe0, 0x00, 0x1f, 0xe0, 0x00, 0x1f, 0xe0, 0x00, 0x0f, 0xc0, 0x00, 0x03, 0x00
};

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
Adafruit_SSD1306 display(128, 64, &Wire, -1);



float coin;

void setup() {
  Serial.begin(115200);
  Serial.println(F("\n\r* * * ESP BOOT * * *"));
  Serial.println(F("WiFi begin!"));
  WiFi.mode(WIFI_STA);
  WiFi.begin("SSID", "Password");

  while (WiFi.status() != WL_CONNECTED) {
    delay(100);
    Serial.print(".");



  }
}

void crypto() {
  std::unique_ptr<BearSSL::WiFiClientSecure>client(new BearSSL::WiFiClientSecure);
  client->setInsecure();
  HTTPClient https;

  if (https.begin(*client, "https://min-api.cryptocompare.com/data/pricemulti?fsyms=XRP&tsyms=ZAR&e=Luno&extraParams=your_app_name")) {  // HTTPS
    Serial.println("[HTTPS] GET...");
    int httpCode = https.GET();

    // httpCode will be negative on error
    if (httpCode > 0) {
      // HTTP header has been send and Server response header has been handled
      Serial.printf("[HTTPS] GET... code: %d\n", httpCode);
      // file found at server?
      if (httpCode == HTTP_CODE_OK) {
        String payload = https.getString();

        const size_t capacity = 2 * JSON_OBJECT_SIZE(1) + 10;
        DynamicJsonDocument doc(capacity);

        String json = payload;

        //const char* json = "{\"XRP\":{\"ZAR\":4.20}}";

        deserializeJson(doc, json);

        float XRP_ZAR = doc["XRP"]["ZAR"]; // 4.20

        coin = XRP_ZAR;

        Serial.print("Current Price: ");
        Serial.print("R");
        Serial.print(coin);
        Serial.println("");

        // initialize with the I2C addr 0x3C
        display.begin(SSD1306_SWITCHCAPVCC, 0x3C);

        // Clear the buffer.
        display.clearDisplay();

        // Display Text

        display.drawBitmap(10, 0,  NaN, 21, 21, WHITE);
        display.display();
        display.setTextSize(2);
        display.setTextColor(WHITE);
        display.setCursor(45, 5);
        display.println("Ripple");


        // Scroll part of the screen
        display.setTextSize(3);
        display.setCursor(10, 35);
        display.println("R");
        display.setCursor(35, 35);
        display.println(coin);
        display.display();
        display.startscrollleft(0x04, 0x07);
        display.display();
        delay(2000);
        display.clearDisplay();



      }
    } else {
      Serial.printf("[HTTPS] GET... failed, error: %s\n\r", https.errorToString(httpCode).c_str());
    }

    https.end();
  } else {
    Serial.printf("[HTTPS] Unable to connect\n\r");
  }
}

void loop() {
  crypto();
  Serial.println("Wait 30s before next round to not get banned on API server...");
  delay(30000);
}
